import { IgrSplineFragmentBase } from "./igr-spline-fragment-base";
import { SplineFragment } from "./SplineFragment";
/**
 * Represents one part of a StackedSplineSeries.
*/
export class IgrSplineFragment extends IgrSplineFragmentBase {
    createImplementation() {
        return new SplineFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline() {
        return this.i.ej;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.dg;
    }
}
