/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-react-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cw.tc;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.s7 = null;
        _this.tb = null;
        _this.ue = { $type: Point_$type, x: 0, y: 0 };
        _this.s9 = null;
        _this.s8 = null;
        _this.s9 = new RadialFrame(3);
        _this.s7 = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.by = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.kz = function () {
        _super.prototype.kz.call(this);
        this.rt = null;
        this.r0 = null;
    };
    AnchoredRadialSeries.prototype.h1 = function (a, b) {
        var c = this.jv(b);
        if (c == AnchoredRadialSeries.$$p[2]) {
            return this.h2(a, b, this.ts);
        }
        return _super.prototype.h1.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.l4 = function (a) {
        _super.prototype.l4.call(this, a);
        this.s6 = a;
    };
    AnchoredRadialSeries.prototype.ho = function (a, b) {
        return this.hp(a, b, this.rt, null, this.tc);
    };
    AnchoredRadialSeries.prototype.hm = function (a, b) {
        return this.hn(a, b, this.rt, null, this.tc);
    };
    AnchoredRadialSeries.prototype.f7 = function (a, b, c, d, e) {
        if (this.tc == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.f8(a, b, this.rt, d, e, this.tc.count, null);
    };
    AnchoredRadialSeries.prototype.gn = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.b1);
        var e = this.th(this.rt, this.b1.bv, this.b1.bu, d);
        var f = new ScalerParams(0, this.b1.bv, this.b1.bu, this.rt.cg, d);
        f.c = this.ce.tp;
        return this.gp(this.tc, a, this.rt, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.ps = function (a, b, c) {
        if (this.r0 == null || this.rt == null || this.b1 == null || this.b1.bv.isEmpty || this.b1.bu.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.b1);
        var e = new ScalerParams(0, this.b1.bv, this.b1.bu, this.r0.cg, d);
        e.c = this.getEffectiveViewport1(this.b1);
        var f = this.gn(a, b, c);
        f = this.r0.ei(f, e);
        var g = this.r1.c(a);
        if (!b && this.rt != null) {
            var h = this.ho(a, c);
            var i = this.hm(a, c);
            var j = this.th(this.rt, this.b1.bv, this.b1.bu, d);
            var k = new ScalerParams(0, this.b1.bv, this.b1.bu, this.rt.cg, d);
            k.c = this.ce.tp;
            var l = this.f7(a, h, this.rt, k, j);
            var m = this.f7(a, i, this.rt, k, j);
            if (m <= l) {
                g = this.rt.ei(i, k) + j;
            }
            else {
                g = this.rt.ei(h, k) + j;
            }
        }
        var n = this.r1.d(g, f, this.b1.bv, this.b1.bu);
        var o = this.r1.e(g, f, this.b1.bv, this.b1.bu);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "tc", {
        get: function () {
            return this.tb;
        },
        set: function (a) {
            if (this.tb != a) {
                var b = this.tb;
                this.tb = a;
                this.raisePropertyChanged("ValueColumn", b, this.tb);
            }
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.getDataLegendSeriesContextAt = function (a, b) {
        var c = new DataLegendSeriesValueInfo();
        c.a = 0;
        c.l = this.gn({ $type: Point_$type, x: a, y: b }, false, false);
        c.p = "Value";
        c.q = this.ts != null ? this.ts : "Value";
        c.r = this.to != null ? this.to : "V:";
        c.s = this.tq != null ? this.tq : "";
        var d = new DataLegendSeriesContext();
        d.f = ((function () {
            var $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
            $ret.add(c);
            return $ret;
        })());
        d.b = this.aw();
        return d;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ua", {
        get: function () {
            return this.c(AnchoredRadialSeries.tz);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.tz, a);
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.aq = function (a) {
        if (a != null && a == this.rt && this.tc != null && this.tc.count > 0) {
            return new AxisRange(0, this.tc.count - 1);
        }
        if (a != null && a == this.r0 && this.tc != null && this.tc.count > 0) {
            return new AxisRange(this.tc.minimum, this.tc.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.l9 = function (a, b, c, d) {
        _super.prototype.l9.call(this, a, b, c, d);
        if (this.s6.cx.g$b(a, b, c, d)) {
            this.mn(false);
            this.lu();
        }
        var e = typeCast(NumericAxisBase.$, this.r0);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.tc);
                    this.tc = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.tc = this.ci(this.ts);
                    this.s6.cs.e(this.fx);
                }
                if (e != null && !e.c0()) {
                    this.s6.cs.e(this.fx);
                    this.mn(false);
                }
                break;
            case AnchoredRadialSeries.$$p[2]:
                if (this.cl != null) {
                    this.cl.deregisterColumn(this.tc);
                    this.tc = this.ci(this.ts);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.c0()) {
                    this.s6.cs.e(this.fx);
                    this.mn(false);
                }
                break;
            case "TrendLineBrush":
                this.m1();
                break;
            case "TrendLineType":
                this.lu();
                break;
        }
    };
    AnchoredRadialSeries.prototype.k5 = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.s6.cs.e(this.fx);
                break;
        }
        this.s6.cx.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.r0 != null && !this.r0.c0()) {
                    this.mn(true);
                }
                break;
            case 1:
                if (this.r0 != null && !this.r0.c0()) {
                    this.mn(true);
                }
                break;
            case 0:
                if (this.r0 != null && !this.r0.c0()) {
                    this.mn(true);
                }
                break;
            case 2:
                if (this.ts != null && this.s6.cs.b > 0 && this.r0 != null && !this.r0.c0()) {
                    this.mn(true);
                }
                break;
            case 3:
                if (d == this.ts) {
                    if (this.r0 != null && !this.r0.c0()) {
                        this.mn(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.fd = function (a, b, c) {
        var d = _super.prototype.fd.call(this, a, b, c);
        var e = c;
        if (this.cl == null || this.cl.count == 0 || this.rt == null || this.tc == null || this.rt.le == 0 || this.r0 == null || isInfinity(this.r0.lw) || isInfinity(this.r0.lv) || e.cs.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.th(this.rt, this.b1.bv, this.b1.bu, this.getEffectiveViewport1(this.b1));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.rt.getCategorySize(this.b1.bv, this.b1.bu, this.getEffectiveViewport1(this.b1));
    };
    AnchoredRadialSeries.prototype.get_tf = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "tf", {
        get: function () {
            return this.get_tf();
        },
        enumerable: false,
        configurable: true
    });
    AnchoredRadialSeries.prototype.get_c7 = function () {
        return true;
    };
    AnchoredRadialSeries.prototype.get_em = function () {
        return this.r0 != null && this.r0.cg;
    };
    AnchoredRadialSeries.prototype.th = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.sn(), b, c, d);
                break;
        }
        if (a.cg) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.sv = function (a, b) {
        var _this = this;
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.rt;
        var g = this.r0;
        var h = g.lw;
        var i = g.lv;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.qn();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.cs.d;
        n = this.th(f, c, d, e);
        l.cx.i = this.r0.nn;
        l.cx.h = this.r0.nm;
        l.cx.j = function (p, q) { return _this.ti(p, q, c, d); };
        l.cx.k = function (p, q) { return _this.tj(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.cs.b;
            $ret.d = b.cs.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.fx;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.cx.l(a.p, this.ta, this.tc, this.tl, function (r) { return _this.rt.getScaledAngle(r); }, function (r) { return _this.r0.nt(r); }, q, p);
        var r = true;
        if (this.tg(b)) {
            o--;
        }
        for (var s = b.cs.c; s <= o; ++s) {
            var t = s;
            if (t * b.cs.b >= this.rt.le) {
                t -= intDivide((this.rt.le), b.cs.b);
            }
            var u = b.cs.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.nt(u[1]);
                if (b.cs.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.nt(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.tf && this.te()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.cs.b, this.cl.count - 1);
                    var w = this.r1.d(u[0], u[1], c, d);
                    var x = this.r1.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.ct.item(k);
                        z.al = t;
                        z.ak = v;
                        z.content.item = this.cl.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.tf && this.te()) {
                    o++;
                }
            }
        }
        b.ct.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.ti = function (a, b, c, d) {
        return this.r1.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.tj = function (a, b, c, d) {
        return this.r1.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.tg = function (a) {
        var b = a;
        return !this.tf && b.cs.c == 0 && b.cs.d == this.rt.le;
    };
    AnchoredRadialSeries.prototype.s5 = function (a, b, c) {
        var d = null;
        var e = c.bv;
        var f = c.bu;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ty = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.td()) {
                a.add(this.ue);
                a.add(a._inner[0]);
                d.add(this.ue);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.te = function () {
        return !this.td();
    };
    AnchoredRadialSeries.prototype.td = function () {
        var a = this.b1.bv;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.k2 = function (a, b) {
        _super.prototype.k2.call(this, a, b);
        var c = b;
        if (a) {
            c.ct.clear();
        }
        c.cx.g$d();
    };
    AnchoredRadialSeries.prototype.sy = function (a, b) {
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pz(b);
        var g = b;
        g.cx.g$g(a.p);
        CategoryMarkerManager.e(this, a.m, g.ct, this.qp);
        this.tv(b, a);
        g.cm();
        this.tu(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.s4 = function (a, b, c) {
        if (b < a || a < 0 || a > this.tc.count || b < 0 || b > this.tc.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cm;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.cl.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.tw = function (a, b, c, d, e, f) {
        var g = this.bl != 1;
        this.r7.a3(this.r7.d, d.cm, a, b, c, d, e, f, true);
        this.r7.aa(this.fv);
        var h = this.r7.ax;
        var i = null;
        var j = this.cl;
        var k = null;
        if (g && this.ce != null) {
            i = this.ce.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.ce.a7.isCrossSeriesHighlight(this)) {
                k = this.ce.a7.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.sw(h);
        this.r7.y(this, i, f, g, h.m, this.ce.a7.totalHighlightingProgress);
    };
    AnchoredRadialSeries.prototype.tx = function (a, b, c, d, e, f) {
        var g = this.bl != 1;
        this.r7.a3(this.r7.b, d.cm, a, b, c, d, e, f, false);
        this.r7.ab(this.fv);
        var h = this.r7.ay;
        var i = null;
        var j = this.cl;
        if (g && this.ce != null) {
            i = this.ce.a7.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.sx(h);
        this.r7.z(this, i, f, g, b < 0);
    };
    AnchoredRadialSeries.prototype.tv = function (a, b) {
        a.b3 = true;
        this.r7.a1(this, this.si(), runOn(this, this.rq), this.sl(a), this.sm(a));
        var c = this.r7.d;
        var d = c != null;
        var e = this.rt;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bv, a.bu, e.cg, f);
        var h = this.cl == null ? 0 : this.cl.count;
        var i = a;
        var j = b.f;
        var k = i.cs.c;
        var l = i.cs.d;
        var m = i.cs.b;
        var n = k * m;
        for (var o = 0; o < a.ct.count; o++) {
            var p = a.ct.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.tw(j, r, h, e, g, a.q);
            }
            this.r7.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.tu = function (a, b, c, d, e) {
        e.cy(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.m1 = function () {
        _super.prototype.m1.call(this);
        if (this.index < 0) {
            return;
        }
        this.s6.cz();
    };
    AnchoredRadialSeries.prototype.h4 = function (a, b) {
        if (a == this.s6.cx.g$j) {
            return null;
        }
        return _super.prototype.h4.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.eq = function (a) {
        var b = this.b1.bv;
        b = b.copy();
        var c = this.b1.bu;
        var d = !b.isEmpty && !c.isEmpty && this.cl != null ? this.cl.indexOf(a) : -1;
        if (this.rt == null || this.tc == null || this.r0 == null) {
            return false;
        }
        if (d < 0 || d > this.tc.count - 1) {
            return false;
        }
        var e = this.rt.getScaledAngle(d);
        var f = this.r0.nt(this.tc.item(d));
        if (isNaN_(f)) {
            f = (this.r0.nm + this.r0.nn) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.b9 != null) {
            this.b9.au(this.ce, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.mp = function (a, b) {
        _super.prototype.mp.call(this, a, b);
        if (!this.e3) {
            this.b1.a2(b);
            return;
        }
        this.b1.a2(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.b0);
        c.cs.e(this.fx);
        if (this.cy(this.b0)) {
            return;
        }
        if (!this.ex) {
            this.s9 = new RadialFrame(3);
            this.sv(this.s9, c);
        }
        this.ex = false;
        this.sy(this.s9, c);
        this.e3 = false;
    };
    AnchoredRadialSeries.prototype.mm = function (a, b, c, d, e) {
        _super.prototype.mm.call(this, a, b, c, d, e);
        var f = this.a7.a$h.item(d);
        var g = f;
        g.cs.e(this.fx);
        f.a1(c);
        if (this.cy(g)) {
            return;
        }
        if (this.s8 == null) {
            this.s8 = new RadialFrame(3);
        }
        this.s8.u();
        this.sv(this.s8, g);
        this.sy(this.s8, g);
    };
    AnchoredRadialSeries.prototype.lc = function (a) {
        _super.prototype.lc.call(this, a);
        this.a9.exportTrendlineData(this, a, this.s6.cx.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.tz = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberAsLegendLabel:to:t7', [2, null], 'ValueMemberAsLegendUnit:tq:t8', [2, null], 'ValueMemberPath:ts:t9', [2, null], 'TrendLineType:ta:t5', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:tk:t4', [1, 1.5], 'TrendLinePeriod:tl:t3', [1, 7], 'TrendLineZIndex:tm:t6', [1, 1], 'TrendLineBrush:ub:t0', [Brush.$, null], 'TrendLineDashArray:uc:t1', [DoubleCollection.$], 'TrendLineDashCap:ud:t2', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cs = new AnchoredRadialBucketCalculator(_this);
        _this.cw = a;
        _this.cx = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cy = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cz = function () {
        this.cw.ua = null;
        if (this.cw.ub != null) {
            this.cw.ua = this.cw.ub;
        }
        else {
            this.cw.ua = this.cw.o5;
        }
    };
    AnchoredRadialSeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cw.ta != 0 && !b) {
                var c = this.cx.g$j;
                c.ad = this.cw.tk;
                c._stroke = this.cw.ua;
                c.ai = this.cw.uc;
                c.aj = this.cw.ud;
                a.v(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cw.rt.fz != null) {
            a += "<span>${item." + this.cw.rt.fz + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a7.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.title + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.ts + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
