import { EventArgs, Base, Type, Point, IList$1, IEnumerable, IEnumerator$1, IEnumerator, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { Series } from "./Series";
import { List$1 } from "igniteui-react-core";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategorySeries } from "./CategorySeries";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { NumericAxisBase } from "./NumericAxisBase";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Rect } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { SeriesViewer } from "./SeriesViewer";
import { PointCollection } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { IChartLegend } from "igniteui-react-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { RenderSurface } from "./RenderSurface";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Path } from "igniteui-react-core";
import { CategoryMode } from "./CategoryMode";
import { DependencyObject } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { IScaler } from "./IScaler";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { NumericXAxis } from "./NumericXAxis";
import { CategoryYAxis } from "./CategoryYAxis";
import { AnchoredCategoryBucketCalculator } from "./AnchoredCategoryBucketCalculator";
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CollisionAvoider } from "./CollisionAvoider";
import { ICategoryScaler } from "./ICategoryScaler";
import { IBucketizer } from "./IBucketizer";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { IBarSeries } from "./IBarSeries";
import { Color } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { DomRenderer } from "igniteui-react-core";
import { PropertyUpdatedEventArgs } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ValuesHolder } from "./ValuesHolder";
import { PreparationParams } from "./PreparationParams";
import { RenderingContext } from "igniteui-react-core";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Canvas } from "igniteui-react-core";
import { Panel } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class StackedSeriesCreatedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: StackedFragmentSeries);
    c: StackedFragmentSeries;
    get brush(): Brush;
    set brush(a: Brush);
    get legendItemTemplate(): DataTemplate;
    set legendItemTemplate(a: DataTemplate);
    get legendItemBadgeTemplate(): DataTemplate;
    set legendItemBadgeTemplate(a: DataTemplate);
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(a: Visibility);
    get outline(): Brush;
    set outline(a: Brush);
    get dashArray(): DoubleCollection;
    set dashArray(a: DoubleCollection);
    get dashCap(): PenLineCap;
    set dashCap(a: PenLineCap);
    get index(): number;
    get thickness(): number;
    set thickness(a: number);
    get title(): any;
    set title(a: any);
    get transitionDuration(): number;
    set transitionDuration(a: number);
    get transitionEasingFunction(): (time: number) => number;
    set transitionEasingFunction(a: (time: number) => number);
    get markerBrush(): Brush;
    set markerBrush(a: Brush);
    get markerOutline(): Brush;
    set markerOutline(a: Brush);
    get markerStyle(): Style;
    set markerStyle(a: Style);
    get markerTemplate(): DataTemplate;
    set markerTemplate(a: DataTemplate);
    get markerType(): MarkerType;
    set markerType(a: MarkerType);
    get markerThickness(): number;
    set markerThickness(a: number);
    get lineCap(): PenLineCap;
    set lineCap(a: PenLineCap);
}
/**
 * @hidden
 */
export declare abstract class FragmentBase extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    constructor();
    vk: CategoryLineRasterizer;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    private vm;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dr(): boolean;
    protected get_dx(): boolean;
    ju(): string;
    hh(): number;
    hl(): number;
    resolveLegendIndex(): number;
    bg(): Series;
    rw(): CategoryAxisBase;
    vj(): CategoryFramePreparer;
    sh(): NumericAxisBase;
    vo(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    ps(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private vp;
    vr(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    t1(a: CategorySeriesView): number;
    aq(a: Axis): AxisRange;
    vq(): number;
    vs(a: IChartLegend): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    mp(a: Rect, b: RenderSurface): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragment extends FragmentBase {
    static $t: Type;
    constructor();
    protected by(): SeriesView;
    vt: AreaFragmentView;
    l4(a: SeriesView): void;
    protected get_dg(): boolean;
    protected get_df(): boolean;
    protected r7(): CategoryTransitionInMode;
    protected vv(a: Point, b: boolean): boolean;
    ez(a: Point, b: boolean): boolean;
    private vu;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k2(a: boolean, b: SeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    my(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class ColumnFragment extends FragmentBase {
    static $t: Type;
    protected get_dk(): boolean;
    protected get_d5(): boolean;
    protected gz(): number;
    protected r7(): CategoryTransitionInMode;
    constructor();
    protected by(): SeriesView;
    vu: ColumnFragmentView;
    l4(a: SeriesView): void;
    vx: number;
    vy: number;
    get fragmentXAxis(): CategoryAxisBase;
    get fragmentYAxis(): NumericAxisBase;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    rw(): CategoryAxisBase;
    sh(): NumericAxisBase;
    protected get_c3(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    k2(a: boolean, b: SeriesView): void;
    aq(a: Axis): AxisRange;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    fa(): boolean;
    sx(a: SeriesView): number;
    sy(a: SeriesView): number;
    sz(a: SeriesView): number;
    p3(a: Point): Rect;
    ez(a: Point, b: boolean): boolean;
    protected e2(a: Point, b: boolean): boolean;
    protected v3(a: Rect, b: number): Rect;
    h4(a: any, b: Point): any;
    hy(a: Point): any;
    hk(a: Point): number;
    hi(a: Point): number;
    vo(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    private vw;
    mm(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BarFragment extends ColumnFragment {
    static $t: Type;
    constructor();
    protected get_di(): boolean;
    protected get_d5(): boolean;
    protected get_dk(): boolean;
    protected r7(): CategoryTransitionInMode;
    get barFragmentXAxis(): NumericXAxis;
    get barFragmentYAxis(): CategoryYAxis;
    rw(): CategoryAxisBase;
    protected get_isVertical(): boolean;
    f9(a: Point): number;
    sh(): NumericAxisBase;
    protected v3(a: Rect, b: number): Rect;
    p3(a: Point): Rect;
    ez(a: Point, b: boolean): boolean;
    vo(a: ISupportsMarkers, b: CategoryFrame, c: number[], d: IDetectsCollisions, e: number, f: number, g: number, h: number): boolean;
    hy(a: Point): any;
    hk(a: Point): number;
    t1(a: CategorySeriesView): number;
    protected l9(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    getBucket(a: number): number[];
}
/**
 * @hidden
 */
export declare class StackedBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedBarBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    g(a: number): void;
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class StackedColumnBucketCalculator extends StackedBucketCalculator {
    static $t: Type;
    constructor(a: CategorySeriesView);
    getBucket(a: number): number[];
    getBucket1(a: AnchoredCategorySeries, b: number, c: number, d: Rect, e: Rect, f: CategoryFrame): number[];
}
/**
 * @hidden
 */
export declare class FragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: FragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare class LineFragment extends FragmentBase {
    static $t: Type;
    protected get_d4(): boolean;
    constructor();
    protected by(): SeriesView;
    vt: LineFragmentView;
    l4(a: SeriesView): void;
    protected vv(a: Point, b: boolean): boolean;
    protected get_dg(): boolean;
    ez(a: Point, b: boolean): boolean;
    private vu;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k2(a: boolean, b: SeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class SplineFragmentBase extends SplineSeriesBase {
    static $t: Type;
    private _logicalSeriesLink;
    get logicalSeriesLink(): StackedFragmentSeries;
    set logicalSeriesLink(a: StackedFragmentSeries);
    v3: CategoryLineRasterizer;
    constructor();
    private v5;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    protected get_dr(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_dx(): boolean;
    ju(): string;
    ps(a: Point, b: boolean, c: boolean): Point;
    ag(): Axis[];
    private v7;
    hh(): number;
    resolveLegendIndex(): number;
    hl(): number;
    bg(): Series;
    vp(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    aq(a: Axis): AxisRange;
    v8(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericYAxis, f: CategorySeriesView): void;
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    vj(a: CategorySeriesView): number[][];
    vk(a: CategorySeriesView): number[][];
    vy(a: CategorySeriesView): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineAreaFragment extends SplineFragmentBase {
    static $t: Type;
    constructor();
    protected by(): SeriesView;
    l4(a: SeriesView): void;
    private v9;
    ac(): void;
    protected get_dg(): boolean;
    protected get_df(): boolean;
    protected get_ej(): boolean;
    protected r7(): CategoryTransitionInMode;
    protected wb(a: Point, b: boolean): boolean;
    ez(a: Point, b: boolean): boolean;
    private wa;
    wd: PointCollection;
    k2(a: boolean, b: SeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    mp(a: Rect, b: RenderSurface): void;
    wc(a: PointCollection, b: List$1<number[]>, c: CategorySeriesView): void;
    t1(a: CategorySeriesView): number;
    my(): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragment extends SplineFragmentBase {
    static $t: Type;
    protected get_ej(): boolean;
    constructor();
    protected by(): SeriesView;
    v9: SplineFragmentView;
    l4(a: SeriesView): void;
    protected wb(a: Point, b: boolean): boolean;
    protected get_dg(): boolean;
    ez(a: Point, b: boolean): boolean;
    private wa;
    k2(a: boolean, b: SeriesView): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare class SplineFragmentBaseValueList extends Base implements IList$1<number> {
    static $t: Type;
    private a;
    constructor(a: SplineFragmentBase);
    indexOf(a: number): number;
    insert(a: number, b: number): void;
    removeAt(a: number): void;
    item(a: number, b?: number): number;
    add(a: number): void;
    clear(): void;
    contains(a: number): boolean;
    copyTo(a: number[], b: number): void;
    get count(): number;
    get isReadOnly(): boolean;
    remove(a: number): boolean;
    getEnumerator(): IEnumerator$1<number>;
    getEnumeratorObject(): IEnumerator;
}
/**
 * @hidden
 */
export declare abstract class StackedSeriesBase extends CategorySeries implements IIsCategoryBased {
    static $t: Type;
    constructor();
    lp(): void;
    protected get_d0(): boolean;
    getHostReferenceValue(): number;
    protected by(): SeriesView;
    tv: StackedSeriesView;
    l4(a: SeriesView): void;
    l5(a: Rect, b: Rect): void;
    private _series;
    get series(): StackedSeriesCollection;
    set series(a: StackedSeriesCollection);
    hq(): number;
    lf(a: (arg1: Series) => boolean): void;
    tw: boolean;
    ty: boolean;
    protected get_isStacked(): boolean;
    seriesCreated: (sender: any, e: StackedSeriesCreatedEventArgs) => void;
    ul: Visibility;
    t4: number;
    t3: number;
    tm: number[];
    tn: number[];
    tu: StackedSeriesManager;
    tr: StackedSeriesCollection;
    get tq(): StackedSeriesCollection;
    private ua;
    private ug;
    private uf;
    mv(a: Point): void;
    r3(a: CategorySeriesView): CategoryFramePreparer;
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    mo(a: boolean): void;
    k2(a: boolean, b: SeriesView): void;
    ub(): void;
    uh(): void;
    protected get_tx(): boolean;
    get tx(): boolean;
    eq(a: any): boolean;
    aq(a: Axis): AxisRange;
    qn(): boolean;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    tp(): CategorySeriesView;
    t1(): number;
    t2(): number;
    t6(a: StackedFragmentSeries): number;
    t5(a: Point): number;
    tz(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    private t0;
    uc(): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    ue(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ar(a: Rect): AxisRange;
    mq(): void;
    protected ud(): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    protected eu(): boolean;
    protected get_dr(): boolean;
    mp(a: Rect, b: RenderSurface): void;
    to: CategoryFrame;
    mm(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    hx(): any;
    get mayContainUnknowns(): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: CategoryAxisBase;
    protected get_c7(): boolean;
    protected get_em(): boolean;
    bw(): SeriesPlotAreaMarginHorizontalMode;
    bx(): SeriesPlotAreaMarginVerticalMode;
    yAxis: NumericYAxis;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    ag(): Axis[];
    sr(): boolean;
    my(): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    up(a: any): boolean;
    uo(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_df(): boolean;
    constructor();
    ac(): void;
    protected by(): SeriesView;
    uu: StackedAreaSeriesView;
    l4(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
}
/**
 * @hidden
 */
export declare abstract class VerticalStackedSeriesBase extends StackedSeriesBase {
    static $t: Type;
    xAxis: NumericXAxis;
    yAxis: CategoryYAxis;
    rw(): CategoryAxisBase;
    sh(): NumericAxisBase;
    bw(): SeriesPlotAreaMarginHorizontalMode;
    bx(): SeriesPlotAreaMarginVerticalMode;
    ar(a: Rect): AxisRange;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    protected get_isVertical(): boolean;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    sr(): boolean;
    protected l9(a: any, b: string, c: any, d: any): void;
    up(a: any): boolean;
    uo(a: any): boolean;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedBarSeries extends VerticalStackedSeriesBase implements IBarSeries {
    static $t: Type;
    protected get_di(): boolean;
    protected get_d5(): boolean;
    protected gz(): number;
    constructor();
    ac(): void;
    protected by(): SeriesView;
    uu: StackedBarSeriesView;
    l4(a: SeriesView): void;
    uv: number;
    uw: number;
    tp(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    s0(): number;
    t1(): number;
    t2(): number;
    aq(a: Axis): AxisRange;
    eq(a: any): boolean;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    protected k5(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    hi(a: Point): number;
    hy(a: Point): any;
    uh(): void;
    t5(a: Point): number;
    tz(a: AnchoredCategorySeries, b: Rect, c: Rect, d: SeriesView): boolean;
    ge(): number;
    ue(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    getPreferredCategoryMode(): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedColumnSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    protected get_dk(): boolean;
    protected get_d5(): boolean;
    protected gz(): number;
    constructor();
    protected by(): SeriesView;
    uu: StackedColumnSeriesView;
    l4(a: SeriesView): void;
    uv: number;
    uw: number;
    tp(): CategorySeriesView;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    aq(a: Axis): AxisRange;
    ge(): number;
    ue(a: AnchoredCategorySeries, b: CategoryFrame, c: CategorySeriesView, d: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    uv: boolean;
    protected gz(): number;
    protected get_df(): boolean;
    protected get_ej(): boolean;
    constructor();
    ac(): void;
    protected by(): SeriesView;
    uu: StackedSplineAreaSeriesView;
    l4(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected l9(a: any, b: string, c: any, d: any): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSplineSeries extends HorizontalStackedSeriesBase {
    static $t: Type;
    uv: boolean;
    protected get_ej(): boolean;
    protected gz(): number;
    constructor();
    ac(): void;
    protected by(): SeriesView;
    uu: StackedSplineSeriesView;
    l4(a: SeriesView): void;
    aq(a: Axis): AxisRange;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedFragmentSeries extends DependencyObject implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    itemsSource: IEnumerable;
    kb: Brush;
    j6: Brush;
    kk: DoubleCollection;
    kj: DoubleCollection;
    kn: PenLineCap;
    kl: PenLineCap;
    at: boolean;
    ak: boolean;
    bz: number;
    bg: number;
    ki: Color;
    kh: Color;
    a3: boolean;
    aq: boolean;
    b0: number;
    bh: number;
    b1: number;
    bi: number;
    ko: PenLineCap;
    km: PenLineCap;
    au: boolean;
    al: boolean;
    g8: DataTemplate;
    g5: DataTemplate;
    g9: DataTemplate;
    g6: DataTemplate;
    k6: Visibility;
    k4: Visibility;
    r: LegendItemBadgeShape;
    p: LegendItemBadgeMode;
    q: LegendItemBadgeShape;
    o: LegendItemBadgeMode;
    kc: Brush;
    j7: Brush;
    kd: Brush;
    j8: Brush;
    k3: Style;
    k2: Style;
    ha: DataTemplate;
    g7: DataTemplate;
    x: MarkerType;
    w: MarkerType;
    t: MarkerFillMode;
    s: MarkerFillMode;
    v: MarkerOutlineMode;
    u: MarkerOutlineMode;
    en: string;
    bw: number;
    bd: number;
    ke: Brush;
    j9: Brush;
    kf: Brush;
    ka: Brush;
    bk: number;
    a9: number;
    bu: number;
    bb: number;
    aa: SeriesOutlineMode;
    z: SeriesOutlineMode;
    bt: number;
    ba: number;
    bx: number;
    be: number;
    am: boolean;
    av: boolean;
    by: number;
    bf: number;
    b2: number;
    bj: number;
    bv: number;
    bc: number;
    ch: any;
    ci: any;
    cd: any;
    ah: (time: number) => number;
    cb: number;
    cc: number;
    ai: (time: number) => number;
    n: CategoryTransitionInMode;
    aw: boolean;
    ad: TransitionInSpeedType;
    an: boolean;
    b5: number;
    m: CategoryTransitionInMode;
    ac: TransitionInSpeedType;
    ag: (time: number) => number;
    af: (time: number) => number;
    b4: number;
    a2: boolean;
    ap: boolean;
    a1: boolean;
    ao: boolean;
    fg: string;
    fc: string;
    fe: string;
    dt: string;
    dv: string;
    ce(a: number, b: number): any;
    k7: Visibility;
    k5: Visibility;
    private _parentSeries;
    get parentSeries(): StackedSeriesBase;
    set parentSeries(a: StackedSeriesBase);
    ca: number;
    ae: SeriesViewer;
    aj: IFastItemColumn$1<number>;
    private _visualSeriesLink;
    get visualSeriesLink(): AnchoredCategorySeries;
    set visualSeriesLink(a: AnchoredCategorySeries);
    a6: List$1<number>;
    a7: List$1<number>;
    a5: List$1<number[]>;
    ay: boolean;
    b6(a: Point): number;
    cf(a: Point): any;
    b9(a: Point, b: boolean): number;
    b8(a: Point, b: boolean): number;
    br(a: Point, b: boolean, c: boolean): number;
    ku(a: Point, b: boolean, c: boolean): Point;
    ky(a: Point): Rect;
    j(a: Point): Rect[];
    kz(a: Point): Rect;
    k(a: Point): Rect[];
    k0(a: Point): Rect;
    k1(a: Point): Rect;
    bn(a: Point, b: boolean, c: boolean): number;
    kq(a: Point, b: boolean, c: boolean): Point;
    bp(a: Point, b: boolean, c: boolean): number;
    ks(a: Point, b: boolean, c: boolean): Point;
    kv(a: Point, b: boolean, c: boolean): Point;
    bs(a: Point, b: boolean, c: boolean): number;
    kr(a: Point, b: boolean, c: boolean): Point;
    bo(a: Point, b: boolean, c: boolean): number;
    kt(a: Point, b: boolean, c: boolean): Point;
    bq(a: Point, b: boolean, c: boolean): number;
    b7(a: Point): number;
    bm(): number;
    bl(a: Point): number;
    cg(a: Point): any;
    ar(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    kw(a: Point): Point;
    kp(a: Point): Point;
    az(a: any): boolean;
    kx(): Rect;
    fk(): void;
    fp(a: Point): void;
    a0(a: Point, b: boolean): boolean;
    fj(a: Point): void;
    b3: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    kg: Brush;
    g4(): void;
    gc(): void;
    ge(): void;
    fr(): void;
    fs(): void;
    fu(): void;
    gi(): void;
    f8(): void;
    ft(): void;
    fv(): void;
    gl(): void;
    gm(): void;
    g0(): void;
    gn(): void;
    go(): void;
    fw(): void;
    f2(): void;
    f3(): void;
    f4(): void;
    f1(): void;
    f0(): void;
    f6(): void;
    f9(): void;
    gb(): void;
    gf(): void;
    gg(): void;
    gh(): void;
    fz(): void;
    fq(): void;
    fx(): void;
    gj(): void;
    gk(): void;
    f5(): void;
    gp(): void;
    gd(): void;
    gr(): void;
    gt(): void;
    gs(): void;
    gv(): void;
    gw(): void;
    gx(): void;
    fy(): void;
    gu(): void;
    gz(): void;
    gq(): void;
    f7(): void;
    ga(): void;
    gy(): void;
    g2(): void;
    g1(): void;
    g3(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected fn(a: string, b: any, c: any): void;
    private a4;
    private as;
    private ax;
    protected fl(a: any, b: string, c: any, d: any): void;
    fo(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class StackedSeriesCollection extends ObservableCollection$1<StackedFragmentSeries> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesFramePreparer extends CategoryFramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected j(a: PreparationParams): ValuesHolder;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
}
/**
 * @hidden
 */
export declare class AreaFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: AreaFragment;
    as(): void;
    constructor(a: AreaFragment);
    dg: Path;
    di: Path;
    dh: Path;
    dj: Path;
    dc: Path;
    de: Path;
    dd: Path;
    df: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class ColumnFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: ColumnFragment;
    as(): void;
    constructor(a: ColumnFragment);
    protected de: List$1<Rectangle>;
    db: Pool$1<Rectangle>;
    dc: List$1<number>;
    dd: List$1<number>;
    private dk;
    private df;
    private dh;
    private dg;
    protected be(a: any, b: number): void;
    di(a: Rectangle, b: number, c: number): void;
    protected bf(a: any, b: number): void;
    protected ac(a: number): any;
    private dj;
    protected ab(a: number): any;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
    getDefaultTooltipTemplate(): string;
}
/**
 * @hidden
 */
export declare class LineFragmentView extends AnchoredCategorySeriesView {
    static $t: Type;
    da: LineFragment;
    constructor(a: LineFragment);
    dg: Path;
    df: Path;
    dh: Path;
    dd: Path;
    dc: Path;
    de: Path;
    db(): void;
    cs(): CategoryBucketCalculator;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineAreaFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    private dc;
    as(): void;
    constructor(a: SplineAreaFragment);
    di: Path;
    dk: Path;
    dj: Path;
    dl: Path;
    de: Path;
    dg: Path;
    df: Path;
    dh: Path;
    dd(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class SplineFragmentView extends SplineSeriesBaseView {
    static $t: Type;
    dc: SplineFragment;
    constructor(a: SplineFragment);
    cs(): CategoryBucketCalculator;
    di: Path;
    dh: Path;
    dj: Path;
    df: Path;
    de: Path;
    dg: Path;
    dd(): void;
    protected bb(): void;
    protected bc(): void;
    protected a6(a: RenderingContext, b: boolean): void;
    protected get_index(): number;
    al(a: any): void;
}
/**
 * @hidden
 */
export declare class StackedSeriesView extends CategorySeriesView {
    static $t: Type;
    c0: StackedSeriesBase;
    private readonly c1;
    get c2(): Canvas;
    private readonly c3;
    get c4(): Panel;
    constructor(a: StackedSeriesBase);
    cs(): CategoryBucketCalculator;
    ap(): void;
    ar(a: RenderingContext, b: RenderingContext): void;
    protected af(): void;
}
/**
 * @hidden
 */
export declare class StackedBarSeriesView extends StackedSeriesView {
    static $t: Type;
    c5: StackedBarSeries;
    constructor(a: StackedBarSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedColumnSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedColumnSeries);
    cs(): CategoryBucketCalculator;
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedAreaSeries);
    as(): void;
}
/**
 * @hidden
 */
export declare class StackedSplineAreaSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineAreaSeries);
    as(): void;
    c5(): number;
}
/**
 * @hidden
 */
export declare class StackedSplineSeriesView extends StackedSeriesView {
    static $t: Type;
    constructor(a: StackedSplineSeries);
    as(): void;
    c5(): number;
}
/**
 * @hidden
 */
export declare class StackedSeriesManager extends Base {
    static $t: Type;
    constructor(a: StackedSeriesBase);
    b: StackedSeriesBase;
    f: ObservableCollection$1<AnchoredCategorySeries>;
    c: StackedSeriesCollection;
    e: ObservableCollection$1<AnchoredCategorySeries>;
    d: ObservableCollection$1<AnchoredCategorySeries>;
    k: Canvas;
    l: Panel;
    a(a: StackedFragmentSeries): AnchoredCategorySeries;
    j(): void;
    private i;
    h(a: boolean): void;
    private g;
}
