import { IgrSeries } from "./igr-series";
import { CalloutAnnotation as CalloutAnnotation_internal } from "./CalloutAnnotation";
/**
 * Represents a callout annotation
*/
export declare class IgrCalloutAnnotation {
    protected createImplementation(): CalloutAnnotation_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): CalloutAnnotation_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the XValue at which this annotation is displayed on the axis.
    */
    get xValue(): any;
    set xValue(v: any);
    /**
     * Gets or sets the YValue at which this annotation is displayed on the axis.
    */
    get yValue(): any;
    set yValue(v: any);
    /**
     * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
    */
    get text(): string;
    set text(v: string);
    /**
     * Gets or sets the Key that should be annotated.
    */
    get key(): any;
    set key(v: any);
    /**
     * Gets or sets the Content that should be annotated.
    */
    get content(): any;
    set content(v: any);
    /**
     * Gets or sets the series to which the callout pertains to. Leave unset for an automatic value.
    */
    get series(): IgrSeries;
    set series(v: IgrSeries);
    /**
     * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
    */
    get formatLabel(): (item: any) => string;
    set formatLabel(v: (item: any) => string);
    /**
     * Gets or sets the color to use for the text in the annotation.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the background to use for tha axis annotation box.
    */
    get background(): string;
    set background(v: string);
    /**
     * Gets or sets the Outline to use for tha axis annotation box.
    */
    get outline(): string;
    set outline(v: string);
    /**
     * Gets or sets the LeaderBrush to use for tha axis annotation box.
    */
    get leaderBrush(): string;
    set leaderBrush(v: string);
    /**
     * Gets or sets the border stroke thickness to use for tha axis annotation box.
    */
    get strokeThickness(): number;
    set strokeThickness(v: number);
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingLeft(): number;
    set backgroundPaddingLeft(v: number);
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingTop(): number;
    set backgroundPaddingTop(v: number);
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingRight(): number;
    set backgroundPaddingRight(v: number);
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingBottom(): number;
    set backgroundPaddingBottom(v: number);
    /**
     * Gets or sets the corner radius to use for the callout borders.
    */
    get backgroundCornerRadius(): number;
    set backgroundCornerRadius(v: number);
    findByName(name: string): any;
}
