import { DataAbbreviationMode } from "igniteui-react-core";
import { DataLegendStylingColumnEventArgs as DataLegendStylingColumnEventArgs_internal } from "./DataLegendStylingColumnEventArgs";
/**
 * Represents styling event args for a column in data legend
*/
export declare class IgrDataLegendStylingColumnEventArgs {
    protected createImplementation(): DataLegendStylingColumnEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataLegendStylingColumnEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets index of column
    */
    get columnIndex(): number;
    set columnIndex(v: number);
    /**
     * Gets index of series
    */
    get seriesIndex(): number;
    set seriesIndex(v: number);
    /**
     * Gets title of series
    */
    get seriesTitle(): string;
    set seriesTitle(v: string);
    /**
     * Gets original value of series without any abbreviation or formatting
    */
    get valueOriginal(): number;
    set valueOriginal(v: number);
    /**
     * Gets name of data column that corresponds to the value, e.g. "OpenPrice"
    */
    get valueMemberPath(): string;
    set valueMemberPath(v: string);
    /**
     * Gets label of data column that corresponds to the value, e.g. "Open"
    */
    get valueMemberLabel(): string;
    set valueMemberLabel(v: string);
    /**
     * Gets a mode used to abbreviate original value to ValueText
    */
    get valueAbbreviation(): DataAbbreviationMode;
    set valueAbbreviation(v: DataAbbreviationMode);
    /**
     * Gets or sets label text displayed before value text in the column
    */
    get labelText(): string;
    set labelText(v: string);
    /**
     * Gets or sets unit text displayed after value text in the column
    */
    get unitsText(): string;
    set unitsText(v: string);
    /**
     * Gets or sets value text displayed value text in the column
    */
    get valueText(): string;
    set valueText(v: string);
    /**
     * Gets or sets color of label text
    */
    get labelTextColor(): string;
    set labelTextColor(v: string);
    /**
     * Gets or sets color of value text
    */
    get unitsTextColor(): string;
    set unitsTextColor(v: string);
    /**
     * Gets or sets color of unit text
    */
    get valueTextColor(): string;
    set valueTextColor(v: string);
}
