import { LegendItemBadgeShape } from "igniteui-react-core";
import { DataLegendStylingRowEventArgs as DataLegendStylingRowEventArgs_internal } from "./DataLegendStylingRowEventArgs";
/**
 * Represents styling event args for a row in data legend
*/
export declare class IgrDataLegendStylingRowEventArgs {
    protected createImplementation(): DataLegendStylingRowEventArgs_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DataLegendStylingRowEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets shape of legend badge in the Data Legend
     * This setting applies only to styling series rows
    */
    get badgeShape(): LegendItemBadgeShape;
    set badgeShape(v: LegendItemBadgeShape);
    /**
     * Gets or sets whether the legend badge is visible in the Data Legend
     * This setting applies only to styling series rows
    */
    get isBadgeVisible(): boolean;
    set isBadgeVisible(v: boolean);
    /**
     * Gets or sets whether the whole row is visible in the Data Legend
    */
    get isRowVisible(): boolean;
    set isRowVisible(v: boolean);
    /**
     * Gets index of series in the chart
    */
    get seriesIndex(): number;
    set seriesIndex(v: number);
    /**
     * Gets title of series in the chart
    */
    get seriesTitle(): string;
    set seriesTitle(v: string);
    /**
     * Gets or sets title text displayed in row of Data Legend
    */
    get titleText(): string;
    set titleText(v: string);
    /**
     * Gets or sets color of title text
    */
    get titleTextColor(): string;
    set titleTextColor(v: string);
}
