import { IgrContourValueResolver, IIgrContourValueResolverProps } from "./igr-contour-value-resolver";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
export declare class IgrLinearContourValueResolver extends IgrContourValueResolver<IIgrLinearContourValueResolverProps> {
    protected createImplementation(): LinearContourValueResolver;
    /**
                                 * @hidden
                                 */
    get i(): LinearContourValueResolver;
    constructor(props: IIgrLinearContourValueResolverProps);
    /**
     * Gets or sets how many contour values to return.
    */
    get valueCount(): number;
    set valueCount(v: number);
}
export interface IIgrLinearContourValueResolverProps extends IIgrContourValueResolverProps {
    /**
     * Gets or sets how many contour values to return.
    */
    valueCount?: number | string;
}
