import { UnknownValuePlotting } from "igniteui-react-core";
import { IgrScatterBase, IIgrScatterBaseProps } from "./igr-scatter-base";
import { ScatterLineSeries } from "./ScatterLineSeries";
/**
 * Represents a IgxDataChartComponent scatter line series
*/
export declare class IgrScatterLineSeries extends IgrScatterBase<IIgrScatterLineSeriesProps> {
    protected createImplementation(): ScatterLineSeries;
    /**
                                 * @hidden
                                 */
    get i(): ScatterLineSeries;
    constructor(props: IIgrScatterLineSeriesProps);
    /**
     * Gets whether the current series shows only line shapes.
    */
    get isLineOnly(): boolean;
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting(): UnknownValuePlotting;
    set unknownValuePlotting(v: UnknownValuePlotting);
}
export interface IIgrScatterLineSeriesProps extends IIgrScatterBaseProps {
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting?: UnknownValuePlotting | string;
}
