import { IgRect } from "igniteui-react-core";
import { IgPoint } from "igniteui-react-core";
import { SliceEventArgs as SliceEventArgs_internal } from "./SliceEventArgs";
/**
 * Contains PieChart click event data.
*/
export declare class IgrSliceEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SliceEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets whether the slice is selected.
    */
    get isSelected(): boolean;
    set isSelected(v: boolean);
    /**
     * Gets or sets whether the slice is exploded.
    */
    get isExploded(): boolean;
    set isExploded(v: boolean);
    /**
     * Gets whether the current slice is part of the others slice.
    */
    get isOthersSlice(): boolean;
    /**
     * Gets the index of the slice that was clicked.
    */
    get index(): number;
    /**
     * Gets the origin location of the slice.
    */
    get origin(): IgPoint;
    /**
     * Gets the radius of the slice.
    */
    get radius(): number;
    /**
     * Gets the bounds of the slice.
    */
    get bounds(): IgRect;
    /**
     * Gets the start angle of the slice.
    */
    get startAngle(): number;
    /**
     * Gets the end angle of the slice.
    */
    get endAngle(): number;
    /**
     * Gets the fill color of the slice.
    */
    get fill(): string;
    /**
     * Gets the outline color of the slice.
    */
    get outline(): string;
    /**
     * Gets the slice data context.
    */
    get dataContext(): any;
    /**
     * Holds a reference to the original event that triggered slice click.
    */
    get originalEvent(): any;
    set originalEvent(v: any);
}
